<?php
jimport('joomla.plugin.plugin');
class plgSystemHikashopuser extends JPlugin{
	function plgSystemHikashopuser(&$subject, $config){
		parent::__construct($subject, $config);
		$app =& JFactory::getApplication();
		$this->cart = $app->getUserState('com_hikashop.cart_id');
		$this->currency = $app->getUserState('com_hikashop.currency_id');
		$this->entries = $app->getUserState('com_hikashop.entries_fields');
    }
    
    function onUserBeforeSave($user, $isnew, $new){
    	return $this->onBeforeStoreUser($user, $isnew);
	}
	function onUserAfterSave($user, $isnew, $success, $msg){
		return $this->onAfterStoreUser($user, $isnew, $success, $msg);
	}
	function onUserAfterDelete($user, $success, $msg){
		return $this->onAfterDeleteUser($user, $success, $msg);
	}
	function onUserLogin($user, $options){
		return $this->onLoginUser($user, $options);
	}
	
	function onBeforeStoreUser($user, $isnew){
		$this->oldUser = $user;
		return true;
	}
	function onAfterStoreUser($user, $isnew, $success, $msg){
		if($success===false) return false;
		if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php')) return true;
		$userClass = hikashop::get('class.user');
		$hikaUser = null;
		$hikaUser->user_email = trim(strip_tags($user['email']));
		$hikaUser->user_cms_id = (int)$user['id'];
		if(!empty($hikaUser->user_cms_id)){
			$hikaUser->user_id = $userClass->getID($hikaUser->user_cms_id,'cms');
		}
		if(empty($hikaUser->user_id) && !empty($hikaUser->user_email)){
			$hikaUser->user_id = $userClass->getID($hikaUser->user_email,'email');
		}
		//only save the info if the user already exists in hikashop.
		if(!empty($hikaUser->user_id)){
			$userClass->save($hikaUser,true);
		}
		return true;
	}
	function onAfterDeleteUser($user, $success, $msg){
		if($success===false) return false;
		if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php')) return true;
		$userClass = hikashop::get('class.user');
		$user_id = $userClass->getID($user['email'],'email');
		if(!empty($user_id)){
			$userClass->delete($user_id);
		}
		return true;
	}
	function onLoginUser($user, $options){
		$app =& JFactory::getApplication();
		$cart = $app->getUserState('com_hikashop.cart_id');
		if(!empty($this->cart)){
			$app->setUserState('com_hikashop.cart_id',$this->cart);
		}
		$entries = $app->getUserState('com_hikashop.entries_fields');
		if(empty($entries) && !empty($this->entries)){
			$app->setUserState('com_hikashop.entries_fields',$this->entries);
		}
		$currency = $app->getUserState('com_hikashop.currency_id');
		if(empty($currency) && !empty($this->currency)){
			$app->setUserState('com_hikashop.currency_id',$this->currency);
		}
		
		if(!empty($user['id'])){
			if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php')) return true;
			$userClass = hikashop::get('class.user');
			$user_id = $userClass->getID($user['id'],'cms');
			if(!empty($user_id)){
				$addressClass = hikashop::get('class.address');
				$addresses = $addressClass->getByUser($user_id);
				if(!empty($addresses) && count($addresses)){
					$address = reset($addresses);
					$field = 'address_country';
					if(!empty($address->address_state)){
						$field = 'address_state';
					}
					$zoneClass = hikashop::get('class.zone');
					$zone = $zoneClass->get($address->$field);
					if(!empty($zone)){
						$zone_id = $zone->zone_id;
						$app->setUserState( HIKASHOP_COMPONENT.'.zone_id', $zone->zone_id );
					}
				}
			}
		}
	}
	function onAfterRender(){
		$user=null;
		return $this->onLogoutUser($user);
	}
	
	function onUserLogout($user){
		return $this->onLogoutUser($user);
	}
	
	function onLogoutUser($user){
		$options=null;
		return $this->onLoginUser($user, $options);
	}
}
